package org.rcisoft.core.util;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfCopy;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfReader;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.core.result.Ret;
import org.springframework.stereotype.Component;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by yangzhaojun on 2018/2/6.
 */
@Component
@Slf4j
public class CutPdfUtil {
    public static void main(String[] args) {
//        try {
//            List<String> pdfList = toCutPdf("F:\\桌面整理\\文件\\测试资料\\06_API常用类.pdf","06_API常用类.pdf", 20);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
        List<Long> haveJurisList = new ArrayList<>();
        System.out.println(haveJurisList);
        if (haveJurisList == null || haveJurisList.size() < 1){
            System.out.println(haveJurisList);
        }
    }

    /**
     * 切割pdf 返回list
     *
     * @param filePath 源文件路径
     * @param page     每个pdf页数
     * @return
     * @throws Exception
     */
    public static List<String> toCutPdf(String filePath,String fileName, int page) throws Exception {
        List<String> pdfList = new ArrayList<>();
        long l1 = System.currentTimeMillis();
        int i = 0;
        int j = 1;
        boolean finish = false;
        PdfReader reader = new PdfReader(filePath);
        int pageNum = reader.getNumberOfPages();
        do {
            String path = filePath.replace(fileName,"pdf-"+fileName);
            String newFilePath = path.substring(0, path.lastIndexOf(".")) +File.separator+fileName.substring(0, fileName.lastIndexOf("."))+ "-" + j + ".pdf";
            int end = i + page;
            if (end >= pageNum) {
                end = pageNum;
                finish = true;
            }
            partitionPdfFile(reader, newFilePath, i + 1, end);
            log.debug("---------------第" + j + "个pdf转换完成-----------------");
            i += page;
            j++;
            pdfList.add(newFilePath);
        } while (!finish);
        long l2 = System.currentTimeMillis();
        SimpleDateFormat sdf = new SimpleDateFormat("mm分ss秒");
        log.debug("---------------耗时：" + sdf.format(l2 - l1)+"----------------");
        return pdfList;
    }

    /**
     * 截取pdfFile的第from页至第end页，组成一个新的文件名
     *
     * @param reader
     * @param newFilePath
     * @param from
     * @param end
     */
    public static void partitionPdfFile(PdfReader reader,
                                        String newFilePath, int from, int end) {
        Document document = null;
        PdfCopy copy = null;
        File newFile = new File(newFilePath);
        try {
            if (!newFile.getParentFile().exists()) {
                newFile.getParentFile().mkdirs();
            }
            document = new Document(reader.getPageSize(1));
            copy = new PdfCopy(document, new FileOutputStream(newFilePath));
            document.open();
            for (int j = from; j <= end; j++) {
                document.newPage();
                PdfImportedPage page = copy.getImportedPage(reader, j);
                copy.addPage(page);
            }
            document.close();

        } catch (IOException e) {
            e.printStackTrace();
        } catch (DocumentException e) {
            e.printStackTrace();
        }
    }
}
