package org.rcisoft.core.util;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.bfile.entity.BFile;

import java.io.*;
import java.util.Arrays;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * @describe 压缩多个文件
 * @author zfc
 * @date 2018年1月11日 下午8:34:00
 */
@Slf4j
public class ZipMultiFile {

    public static void main(String[] args) {
        File[] srcFiles = { new File("C:\\Users\\三\\Desktop\\暂时\\deleteFile\\新建文件夹\\avi.mp4"), new File("C:\\Users\\三\\Desktop\\暂时\\deleteFile\\新建文件夹\\新建文件夹\\攻防思路.pptx"), new File("C:\\Users\\三\\Desktop\\暂时\\deleteFile\\新建文件夹\\新建文件夹\\音频.mp3") };
        File zipFile = new File("C:\\Users\\三\\Desktop\\暂时\\deleteFile\\1234\\ZipFile.zip");
        // 调用压缩方法

//        zipFiles(Arrays.asList(srcFiles), zipFile);
    }

    public static String zipFiles(List<BFile> srcFiles, File zipFile) {
        // 判断压缩后的文件存在不，不存在则创建
        if (!zipFile.getParentFile().exists()){
            zipFile.getParentFile().mkdirs();
        }

        if (!zipFile.exists()) {
            try {
                zipFile.createNewFile();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        // 创建 FileOutputStream 对象
        FileOutputStream fileOutputStream = null;
        // 创建 ZipOutputStream
        ZipOutputStream zipOutputStream = null;
        // 创建 FileInputStream 对象
        FileInputStream fileInputStream = null;

        try {
            // 实例化 FileOutputStream 对象
            fileOutputStream = new FileOutputStream(zipFile);
            // 实例化 ZipOutputStream 对象
            zipOutputStream = new ZipOutputStream(fileOutputStream);
            // 创建 ZipEntry 对象
            ZipEntry zipEntry = null;
            // 遍历源文件数组
            for (int i = 0; i < srcFiles.size(); i++) {
                // 将源文件数组中的当前文件读入 FileInputStream 流中
                fileInputStream = new FileInputStream(new File(srcFiles.get(i).getFileUrl()));
                // 实例化 ZipEntry 对象，源文件数组中的当前文件
                zipEntry = new ZipEntry(srcFiles.get(i).getFileName()+srcFiles.get(i).getFileUrl().substring(srcFiles.get(i).getFileUrl().lastIndexOf(".")));
                zipOutputStream.putNextEntry(zipEntry);
                // 该变量记录每次真正读的字节个数
                int len;
                // 定义每次读取的字节数组
                byte[] buffer = new byte[1024];
                while ((len = fileInputStream.read(buffer)) > 0) {
                    zipOutputStream.write(buffer, 0, len);
                }
                fileInputStream.close();
            }

        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            try {
                zipOutputStream.closeEntry();
            } catch (IOException e) {
                e.printStackTrace();
            }
            closeStream(zipOutputStream);
            closeStream(fileInputStream);
            closeStream(fileOutputStream);
        }
        return zipFile.getPath();
    }

    private static void closeStream(Closeable stream){
        try{
            if(stream != null){
                stream.close();
            }
        }catch(Exception e){
            log.error("关闭流错误！", e);
        }
    }
}